const Echo =  require("laravel-echo");
const SocketClient = require("socket.io-client");
const config = require('electron-node-config');
$(document).ready(function () {
    const Store = require('electron-store');
    const store = new Store();
    var moment = require('moment');
    window.io = SocketClient;
    const host = config.get('host');
    const host_socket = config.get('socket_host');
    const token = store.get('token');
    const user_id = store.get('user_id');
    let username = store.get('username');
    var badge = 0
    var credentials = {}
    var bucket = ''
    getCredential()
    const path = require('path');
    const os = require('os');
    var platform = os.platform()
    // get custom aws cli config from file.
    const app = require('electron').remote.app;
    var awsConfigFile = app.getAppPath() + '/aws-config';
    var dir =path.join(__dirname, '../../');
    if(platform == 'win32'){
        dir = dir.replace(/\\/g, "\\\\")+ "libs\\\\"
        var awsclifolder = 'AWSCLIV2WIN'
        awsConfigFile = app.getAppPath().replace(/\\/g, "\\\\") + '\\\\aws-config';
    }else if(platform == 'darwin'){
        dir = dir + "/libs/"
        var awsclifolder = 'AWSCLIV2MAC'
    }else if(platform == 'linux'){
        dir = dir + "libs/"
        var awsclifolder = 'AWSCLIV2LINUX'
    }

    var bucketURL = 's3://' + bucket + '/';
    var outputFolder = bucketURL + username;

    window.Echo = new Echo({
        broadcaster: 'socket.io',
        host: host_socket,
        auth: {
            headers: {
                Authorization: 'Bearer '+ token
            },
        },
    });


    window.Echo.private('chanel.user.'+user_id)
    .listen('UpdateJobStatus', (data) => {
        var jobStatus = '.job-'+data.job.id+'-status'
        var jobSubmit = '.job-'+data.job.id+'-submit-at'
        var jobStart = '.job-'+data.job.id+'-start-at'
        var jobComplete = '.job-'+data.job.id+'-complete-at'
        var status_noti = ['completed','paused','failed']
        if(status_noti.includes(data.job.status)){
            badge+=1
            $('.nav-drop-default-item').html('')
            $('.badge').show();
            $('.badge').html(badge);
            if($('.notification-dropdown').children().length >= 5){
                $('.notification-dropdown').children().last().remove()
            }
            var notify ='<li><p class="nav-drop-item">Job #'+data.job.id+' is '+data.job.status+'</p></li>' 
            $('.notification-dropdown').prepend(notify)
        }
        $(jobStatus).html(data.job.status)
        $(jobSubmit).html(momentFormatTime(data.job.created_at))
        $(jobStart).html(momentFormatTime(data.job.started_at))
        $(jobComplete).html(momentFormatTime(data.job.completed_at))

        var method_sync_output = store.get('sync_output_method')
        var syncPath = store.get('autoSyncPath')
        var params = JSON.parse(data.job.param_user_submit)
        var job_name = (params.job_name) ? '_' + params.job_name : ''
        if(method_sync_output == 'AutoSyncOutput' && syncPath != undefined && syncPath != ''){
            syncOutputToLocalPath(syncPath, data.job.id, job_name)
            if(data.job.status == 'completed'){
                setTimeout(()=>{
                    syncOutputToLocalPath(syncPath, data.job.id, job_name)
                },10000)
            }
        }
    })

    function momentFormatTime(time){
        if(!time){
          return "--"
        }
        var gmtDateTime = moment.utc(time, "YYYY-MM-DD HH:mm:ss")
        var local = gmtDateTime.local().format("YYYY-MM-DD HH:mm:ss");
        return local;
    }

    function syncOutputToLocalPath(localpath, id, name) {
        var syncFrom = outputFolder + '/' + id + '/'
        if(platform == 'win32'){
          localpath = localpath + '\\' + id + name
          var execCmd = dir + awsclifolder + '\\\\aws s3 sync "' + syncFrom + '" "' + localpath + '" --output text';
        }else{
          localpath = localpath + '/' + id + name
          var execCmd = dir + awsclifolder + '/aws s3 sync "' + syncFrom + '" "' + localpath + '" --output text';
        }
        
        executeLiveData(execCmd, id, (output) => {
            console.log(output)
        });
    }

    function executeLiveData(command, index, callback) {
        var child = exec(command, {env: {AWS_ACCESS_KEY_ID: credentials.AccessKeyId ,AWS_SECRET_ACCESS_KEY:credentials.SecretAccessKey, AWS_SESSION_TOKEN:credentials.SessionToken, AWS_CONFIG_FILE:awsConfigFile },maxBuffer: 1024 * 1024 * 500});
        child.stdout.on('data', function (data) {
            console.log(data);
        });
        var error = false
        child.stderr.on('data', function (data) {
            console.log('stderr: ' + data.toString());
            error = true
        });
    
        child.on('exit', function (code) {
            
        });
    };
    function getCredential(){
        $.ajax({url: host+"/api/credentials?email=" + store.get('username'),async: false, success: function(result){
            credentials=result.Credentials;
            bucket = result.output_bucket;
        }});
    }
})