const electron = require('electron');
const { BrowserWindow } = require('electron');

const {ipcMain} = require('electron');
const os = require('os');
const path = require('path');
const Store = require('electron-store');
const store = new Store();

function createWindow () {
  // Create the browser window.
  let display = electron.screen.getPrimaryDisplay();
  let width = display.bounds.width;
  let height = display.bounds.height;
  let w = 815;
  let h = 750;
  // console.log(width, height);
  const win = new BrowserWindow({
    icon: __dirname + '../../icons/icon.ico',
    title: "3S Cloud Uploader",
    width: w,
    height: h,
    x: width - w,
    y: (height - h) - 10,
    backgroundColor: '#2e2c29',
    // resizable: false,
    movable: true,
    maximizable: false,
    fullscreenable: false,
    darkTheme: true,
    webPreferences: {
      nodeIntegration: true,
      enableRemoteModule: true
      // webSecurity: false
    }
  })
  win.setMenuBarVisibility(false)

  // and load the index.html of the app.
  var username = store.get('username');
  if(username !== undefined && username != '') {
    win.loadFile('src/linux/main_linux.html');
  } else {
    win.loadFile('src/Login.html');
  }
  ipcMain.on('require-login', (event) => {
    win.loadFile('src/Login.html');
  })
  ipcMain.on('login-success', (event, email) => {
    // console.log('Login success', email);
    store.set('username', email);
    // load main window
    win.loadFile('src/linux/main_linux.html');
  })
  ipcMain.on('go-to-upload-page', (event, email) => {
    // load main window
    win.loadFile('src/linux/main_linux.html');
  })

  ipcMain.on('go-to-syncoutput-page', (event, email) => {
    // load main window
    win.loadFile('src/sync_output/sync_output.html');
  })

  ipcMain.on('go-to-settingoutput-page', (event, email) => {
    // load main window
    win.loadFile('src/sync_output/setting_auto_sync_output.html');
  })
  // Open the DevTools.
  // win.webContents.openDevTools();
}


module.exports = {
  createWindow: createWindow
}
