$(document).ready(function () {
    var request = require('request');
    const { net } = require('electron')
    const config = require('electron-node-config');
    const host = config.get('host');
    const Store = require('electron-store');
    const store = new Store();
    $('#signin-3scloud').on('click', function(event) {
        event.preventDefault();
        let $_this = $(this);
        $('#form-signin').validate();
        // if validate is true

        // disable clicked button
        $_this.prop("disabled", true);
        // add spinner to button
        $_this.html(
            `<span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span> Sign in...`
        );
        // prepare data to submit
        var email = $('#inputEmail').val();
        var pwd = $('#inputPassword').val();
        var formData = {
            'email': email,
            'password': pwd,
            'uploader': 'true'
        }
        // console.log(formData);
        request.post({url:host+'/api/auth/login', formData: formData}, function(err, httpResponse, body) {
            if (err) {
                $_this.html('Sign in');
                $_this.prop("disabled", false);
                $(".login-failed").show();
                return console.error('Login Failed:', err);

            } else if(httpResponse.statusCode != 200) {
                $_this.html('Sign in');
                $_this.prop("disabled", false);
                $(".login-failed").show();
                return console.warn('Login has been redirected');
            } 

            store.set('token',JSON.parse(body).access_token)
            store.set('user_id',JSON.parse(body).user.id)
            // call to main process to load main window.
            const { ipcRenderer } = require('electron')
            ipcRenderer.send('login-success', email)

            // console.log('Login success', email);
        });
    })

    $('#form-signin').validate();
})
document.addEventListener('keydown', event => {
    // console.log(event.key, event.keyCode);
    if (event.key === 'Enter' || event.key === 'Return' || event.keyCode === 13) {
        // trigger to sign in click button
        $('#signin-3scloud').click();
    }
});