const electron = require('electron');
const { app, BrowserWindow } = require('electron');
const os = require('os');


var platform = os.platform()
switch (platform) {
  case 'linux':
    createWindow = require('./linux/main.linux.js').createWindow;
    break;
  case 'darwin':
    createWindow = require('./mac/main.mac.js').createWindow;
    break;
  case 'win32':
    createWindow = require('./win/main.win.js').createWindow;
    break;
  default:
    throw "Unsupported Operation System";
}

// This method will be called when Electron has finished
// initialization and is ready to create browser windows.
// Some APIs can only be used after this event occurs.
app.whenReady().then(createWindow)

// Quit when all windows are closed.
app.on('window-all-closed', () => {
  // On macOS it is common for applications and their menu bar
  // to stay active until the user quits explicitly with Cmd + Q
  if (process.platform !== 'darwin') {
    app.quit()
  }
})

app.on('activate', () => {
  // On macOS it's common to re-create a window in the app when the
  // dock icon is clicked and there are no other windows open.
  if (BrowserWindow.getAllWindows().length === 0 && app.isReady()) {
    createWindow();
  }
})

