$(document).ready(function () {
  const Store = require('electron-store');
  let store = new Store();
  let username = store.get('username');
  var autoSyncOption = store.get('sync_output_method')
  var syncPath = store.get('autoSyncPath')
  const { ipcRenderer } = require('electron')
  // IF Already logged in.
  if(username != undefined && username != '') { 

    $("#setting_loading").remove()

    $("#setting_content").show()

    const dialog = require('electron').remote.dialog;

    if(autoSyncOption == 'AutoSyncOutput'){
        $("#AutoSyncOutput").attr('checked', 'checked');
        $("#div_select_folder_auto_sync").show()
    }else{
        $("#ManualSyncOutput").attr("checked","checked")
        $("#div_select_folder_auto_sync").hide()
    }

    $('input[name="output_sync_method"]' ).on('click', function() {
        var val = $(this).val()
        if(val == 'AutoSyncOutput'){
            $("#div_select_folder_auto_sync").show()
            syncPath = store.get('autoSyncPath')
            if(syncPath == undefined || syncPath == ''){
                $('#btn-save-output-sync-method').attr('disabled', true);
            }
        }else{
            $("#div_select_folder_auto_sync").hide()
            $('#btn-save-output-sync-method').removeAttr('disabled');
        }
    });

    if(syncPath != undefined && syncPath != ''){
        $("#div-select-folder-output").hide()
        $("#div-selected-folder-output").show()
        $("#sync_auto_path").html(syncPath)
    }else{
        $("#div-select-folder-output").show()
        $("#div-selected-folder-output").hide()
    }

    $('.btn-select-folder-to-auto-sync').on('click', function() {
        $('.btn-select-folder-to-auto-sync').attr('disabled', true);
        // open select folder dialog
        dialog.showOpenDialog({ 
            buttonLabel: 'select',
            properties: ['openDirectory'] 
        })
        .then(result => {
            $('.btn-select-folder-to-auto-sync').removeAttr('disabled');
            if(result.canceled == false){
                if(result.filePaths.length > 0){
                    syncPath = result.filePaths[0]
                    $("#div-select-folder-output").hide()
                    $("#div-selected-folder-output").show()
                    $("#sync_auto_path").html(syncPath)
                    $('#btn-save-output-sync-method').removeAttr('disabled');
                } 
            }
        }).catch(err => {
            console.log(err);
        });
    })

    $("#btn-save-output-sync-method").on('click', function(event) {
        var method = $('input[name="output_sync_method"]:checked').val();
        if(method == "AutoSyncOutput"){
            store.set('autoSyncPath',syncPath)
        }else{
            store.delete('autoSyncPath')
        }
        store.set('sync_output_method',method)
        
        ipcRenderer.send('go-to-syncoutput-page')
    })

    $("#btn-cancel-setting-output").on('click', function(event) {
        ipcRenderer.send('go-to-syncoutput-page')
    })

  }

})