const { execSync } = require('child_process');
$(document).ready(function () {
  const Store = require('electron-store');
  let store = new Store();
  let username = store.get('username');
  var moment = require('moment');
  let credentials = {};
  var background_process = {}
  const { ipcRenderer } = require('electron')
  let bucket = '';
  const config = require('electron-node-config');
  const host = config.get('host');
  const token = store.get('token');
  var productionUrl = host
  var autoSyncMethod  = store.get('sync_output_method')
  if(autoSyncMethod == 'AutoSyncOutput'){
    $('#auto_sync_output_text').html('Your auto sync output feature is On, if you want to change settings <a id="go-to-setting-output" style="text-decoration: underline;cursor: pointer;">click here!</a>')
  }else{
    $('#auto_sync_output_text').html('Your auto sync output feature is Off, if you want to change settings <a id="go-to-setting-output" style="text-decoration: underline;cursor: pointer;">click here!</a>')
  }
  $("#go-to-setting-output").on('click', function(event) {
    ipcRenderer.send('go-to-settingoutput-page')
  })
  getCredential()
  getListJob()
  var AWS = require('aws-sdk');
  const path = require('path');
  const os = require('os');
  var platform = os.platform()
  let syncFile = 0;
  let selectJob = 0;
  // get custom aws cli config from file.
  const app = require('electron').remote.app;
  var awsConfigFile = app.getAppPath() + '/aws-config';
  var dir =path.join(__dirname, '../../');
  if(platform == 'win32'){
    dir = dir.replace(/\\/g, "\\\\")+ "libs\\\\"
    var awsclifolder = 'AWSCLIV2WIN'
    awsConfigFile = app.getAppPath().replace(/\\/g, "\\\\") + '\\\\aws-config';
  }else if(platform == 'darwin'){
    dir = dir + "/libs/"
    var awsclifolder = 'AWSCLIV2MAC'
  }else if(platform == 'linux'){
    dir = dir + "libs/"
    var awsclifolder = 'AWSCLIV2LINUX'
  }
  
  // IF Already logged in.
  if(username != undefined && username != '') { 
    // global workspace - s3 bucket & space folder
    var bucketURL = 's3://' + bucket + '/';
    var rootSpace = '3sfarmspaces/';
    // get user name
    // concat to make prefix is userFolder before upload
    var outputFolder = bucketURL + username;

    const dialog = require('electron').remote.dialog;

    var folderToSync = ''

    $('#btn-select-folder-to-sync').on('click', function() {
      $('#btn-select-folder-to-sync').attr('disabled', true);
      $('#btn-download-output').removeClass('btn-sync-visible');
      $('#btn-download-output').removeClass('highlight-bt');
      $('#btn-download-output').removeClass('ready-to-sync');
      $('#btn-download-output').addClass('btn-sync-disabled');
      $('#btn-download-output').html('Download')
      // open select folder dialog
      dialog.showOpenDialog({ 
          buttonLabel: 'select',
          properties: ['openDirectory'] 
      })
      .then(result => {
          $('#btn-select-folder-to-sync').removeAttr('disabled');
          if(result.canceled == false){
            $('#outputConsole-wrapper').html('')
            $('#btn-download-output').removeClass('btn-sync-disabled');
            $('#btn-download-output').addClass('btn-sync-visible');
            $('#btn-download-output').addClass('highlight-bt');
            $('#btn-download-output').addClass('ready-to-sync');
            if(result.filePaths.length > 0){
              DrawSelectedJob()
              folderToSync = result.filePaths[0]
            } 
          }
      }).catch(err => {
          console.log(err);
      });
    })

    $('#btn-download-output').on('click', function() {
      $('#outputConsole-wrapper').html('')
      $('#btn-download-output').html('<span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span> Downloading...')
      $('#btn-cancel-download').removeClass('btn-sync-disabled');
      $('#btn-cancel-download').addClass('btn-sync-visible');
      var checkedFileFolder= $('.file-folder input[name="objFileFolder[]"]:checked');
      if(checkedFileFolder.length > 0){
        selectJob = checkedFileFolder.length
        checkedFileFolder.each(function() {
          if($(this).prop('checked') == true) {
            var id = $(this).data('id');
            var name = $(this).data('name');
            syncOutputToLocalPath(folderToSync,id,name)
          }
        })
      }
    })

    $('#btn-cancel-download').on('click', function(){
      event.preventDefault();
      var checkedFileFolder= $('.file-folder input[name="objFileFolder[]"]:checked');
      checkedFileFolder.each(function() {
        if($(this).prop('checked') == true) {
          $(this).prop('checked',false)
        }
      })
      resetData()
      $('#outputConsole-wrapper').html('')
      if(platform == 'win32'){
        execSync('C:\\Windows\\System32\\taskkill.exe /F /IM aws.exe')     
      }else{
        process_ids = Object.keys(background_process)
        process_ids.map(p => background_process[p].kill());
      }
    })

    $('#refreshBtn').on('click', function(){
      event.preventDefault();
      resetData()
      $('#outputConsole-wrapper').html('')
      getListJob()
    })

    $('body').on('click', '.btn-cancel-upload-select-item', function (event){
      event.preventDefault();
      var index = $(this).data('index')
      $('input[data-id='+index+']').prop('checked',false);
      $(this).parent().remove()
      var checkedFileFolder= $('.file-folder input[name="objFileFolder[]"]:checked');
      if(checkedFileFolder.length <= 0){
        resetData()
      }
    })
  }
  function resetData(){
    $('#btn-download-output').removeClass('btn-sync-visible');
    $('#btn-download-output').removeClass('highlight-bt');
    $('#btn-download-output').removeClass('ready-to-sync');
    $('#btn-download-output').html('Download')
    $('#btn-download-output').addClass('btn-sync-disabled');
    $('#btn-select-folder-to-sync').removeClass('btn-sync-visible');
    $('#btn-select-folder-to-sync').addClass('btn-sync-disabled');
  }
  function getCredential(){
    $.ajax({url: productionUrl+"/api/credentials?email=" + store.get('username'),async: false, success: function(result){
      credentials=result.Credentials;
      bucket = result.output_bucket;
    }});
  }
  function DrawSelectedJob() {
    var selectJobHtml = ''
    var checkedFileFolder= $('.file-folder input[name="objFileFolder[]"]:checked');
    if(checkedFileFolder.length > 0){
      selectJob = checkedFileFolder.length
      checkedFileFolder.each(function() {
        if($(this).prop('checked') == true) {
          var id = $(this).data('id');
          selectJobHtml += '<div class="content-progress-upload" id="selectedJob'+id+'"><div class="alert output-console alert-secondary" role="alert">Sync output job #'+id+'</div><button type="button" class="close btn-cancel-upload-select-item" data-index="'+id+'" aria-label="Close"> <span aria-hidden="true">x</span> </button></div>'; 
        }
      })
    }
    $("#outputConsole-wrapper").html(selectJobHtml)
  }
  function getListJob(){
    var settings = {
      "url": host+"/api/jobs/tool-upload/list-job",
      "method": "GET",
      "timeout": 0,
      "headers": {
        "Authorization": "Bearer " + token
      },
    };
    showLoading()
    
    $.ajax(settings).done(function (response) {
      var ulHtml = '';
      var list_job = response
      $.each(list_job, function(index, item) {
        var params = {"start_frame":'--',"end_frame":'--',"step_frame":'--'}
        if(item.param_user_submit){
          params = JSON.parse(item.param_user_submit)
        }
        var jobDetail = params.start_frame + '-' + params.end_frame +':'+params.step_frame
        if(item.render_preview){
          jobDetail = 'free preview'
        }
        var job_name = ''
        var display_job_name = ''
        var display_scene_name = ' - ' +item.scene_name
        if(params.job_name){
          job_name = params.job_name
          display_job_name = '_' + job_name
          display_scene_name =''
        }
        ulHtml += '<tr>'
        +'<td class="file-folder">'
        +'<input type="checkbox" class="select-folder mr-2 isFolder" name="objFileFolder[]" data-id="'+ item.id +'" data-name="'+ job_name +'">'
        +'</td>'
        +'<td class="job-info">'
        +'<span class="job-extra-info" data-id="'+ item.id +'" data-name="'+ job_name +'">#' + item.id + display_job_name +'['+ jobDetail +']' + display_scene_name + '</span>'
        +'</td>'
        +'<td style="min-width: 120px;">'
        +'<span class="job-extra-info job-'+item.id+'-submit-at">'+momentFormatTime(item.created_at)+'</span>'
        +'</td>'
        +'<td style="min-width: 120px;">'
        +'<span class="job-extra-info job-'+item.id+'-start-at">'+momentFormatTime(item.started_at)+'</span>'
        +'</td>'
        +'<td style="min-width: 120px;">'
        +'<span class="job-extra-info job-'+item.id+'-complete-at">'+momentFormatTime(item.completed_at)+'</span>'
        +'</td>'
        +'<td>'
        +'<span class="job-extra-info job-'+item.id+'-status">'+item.status+'</span>'
        +'</td></tr>';
      })
      var table = '<table style="width: 100%;"><tr><th></th><th>Job</th><th>Submited At</th><th>Started At</th><th>Completed At</th><th>Status</th></tr>'+ulHtml+'</table>'
      $('#listJob').html(table);
      $('.file-folder input[type="checkbox"]').on('click', function() {
        var checkedFolderLength = $('input[name="objFileFolder[]"]:checked').length;
        if(checkedFolderLength > 0){
          $('#btn-select-folder-to-sync').removeClass('btn-sync-disabled');
          $('#btn-select-folder-to-sync').addClass('btn-sync-visible');
        } else {
          resetData()
        }
      })
    });
  }

  function momentFormatTime(time){
    if(!time){
      return "--"
    }
    var gmtDateTime = moment.utc(time, "YYYY-MM-DD HH:mm:ss")
    var local = gmtDateTime.local().format("YYYY-MM-DD HH:mm:ss");
    return local;
  }

  function showLoading(){
    var html = `
    <div class="d-flex justify-content-center">
        <div class="spinner-border text-3s" role="status">
          <span class="sr-only">Loading...</span>
        </div>
      </div>`
    $('#listJob').html(html);
  }

  function syncOutputToLocalPath(localpath, id, name) {
    var outputConsoleId = 'outputConsole-' + id;
    var html = '<div class="content-progress-upload"><div class="alert output-console alert-secondary" role="alert" id="' + outputConsoleId + '"> Sync output job #'+id+' to '+ localpath.replace(/\\\\/g, "\\")+'</div></div>';
    $('#outputConsole-wrapper').append(html);
    var syncFrom = outputFolder + '/' + id + '/'
    if(platform == 'win32'){
      localpath = localpath + '\\' + id + '_' + name
      var execCmd = dir + awsclifolder + '\\\\aws s3 sync "' + syncFrom + '" "' + localpath + '" --output text';
    }else{
      localpath = localpath + '/' + id + '_' + name
      var execCmd = dir + awsclifolder + '/aws s3 sync "' + syncFrom + '" "' + localpath + '" --output text';
    }
    
    console.log(execCmd);
    
    executeLiveData(execCmd, id, (output) => {
      var outputConsoleId = '#outputConsole-' + id;
      $(outputConsoleId).html(output);
    });
  }

  function executeLiveData(command, index, callback) {
    syncFile = 0
    var child = exec(command, {env: {AWS_ACCESS_KEY_ID: credentials.AccessKeyId ,AWS_SECRET_ACCESS_KEY:credentials.SecretAccessKey, AWS_SESSION_TOKEN:credentials.SessionToken, AWS_CONFIG_FILE:awsConfigFile },maxBuffer: 1024 * 1024 * 500});
    var outputConsoleId = '#outputConsole-' + index;
    var outPutDiv = $(outputConsoleId);
    background_process[child.pid]=child
    child.stdout.on('data', function (data) {
      if(!outPutDiv.hasClass('alert-secondary')) {
        outPutDiv.addClass('alert-secondary');
      }
      if(outPutDiv.hasClass('alert-success')) {
        outPutDiv.removeClass('alert-success')
      }
      if($('#outputConsole-wrapper').css('display') == 'none') {
        $('#outputConsole-wrapper').toggle();
      }
      if(data.includes('Completed') && !data.includes('Upload:')) {
        var matches = data.match(/Completed(.*)remaining(.*)/g);
        if(matches.length > 0) {
          outPutDiv.html(matches[0]);
        }
      }
    });
    var error = false;
    child.stderr.on('data', function (data) {
      console.log('stderr: ' + data.toString());
      error = true;
    });

    child.on('exit', function (code) {
      var outputConsoleId = '#outputConsole-' + index;
      var outPutDiv = $(outputConsoleId);
      if(!error) {
        outPutDiv.removeClass('alert-secondary');
        outPutDiv.addClass('alert-success');
        outPutDiv.html('Sync output successfully!');
      }else{
        outPutDiv.removeClass('alert-secondary');
        outPutDiv.addClass('alert-danger');
        outPutDiv.html('Sync output failed!');
      }
      syncFile = syncFile + 1;
      if(syncFile == selectJob){
        $('#btn-download-output').html('Download')
        $('#btn-cancel-download').removeClass('btn-sync-visible');
        $('#btn-cancel-download').addClass('btn-sync-disabled');
        background_process = {}
      }
    });
  };
})